<mapsidebar>
    <style>
        .favoriteimg {
            cursor: pointer;
        }
    </style>
    <div id="mapSideBar">
        <div id="btnFeedbackHome" class="cusDiv {isShow ? 'dispsidebar' : ''}">
            <div id="feedbackIcon">
                <img id="feedbackImgHomeBtn" src="assets/images/map/global-settings_64.png">
            </div>
            <div class="open_nav">
                <!--<h4 class="textCus">端末一覧</h4>-->
                <div id="mapErrorMessage" style="display:none;" class="alert alert-danger nav navbar-nag alert-dismissible mapMessage" role="alert">
                </div>
                <ul class="nav_menu">
                    <li>
                        <gpslist/>
                    </li>
                </ul>
            </div>
            <historygpsinfowindowview />
        </div>
    </div>
<!--    <assetinfo/>-->
    <script>

        export default {
            scrutiny(value) {
                if (Number.isInteger(value)) return value
                if (!value) return ''
                return value.replace(/\s+/g, "") ? value.replace(/\s+/g, "") : ''
            },
            onBeforeMount() {
                this.name = 'gpslist'
                this.isShow = false
                this.realtimeService = new RealtimeService()
                this.mapService = new MapService()
                this.trackService = new TrackService()
                this.mapService.clean()
                WebSocketClient.getInstance().close()
            },
            onUnmounted() {
                this.mapService.clean()
                $('.labels').remove()
            },
            onMounted() {
                $('.labels').remove()
                moment.locale('ja')
                this.mapService.getMap().controls[google.maps.ControlPosition.TOP_RIGHT].push(document.getElementById("mapSideBar"))
                const self = this
                $("#feedbackIcon").on('click', function () {
                    self.isShow = self.isShow ? false : true
                    self.update()
                })
                RiotUtil.next("gpslist", {
                    scrutiny: this.scrutiny,
                    title: '',
                    name: 'gpslist',
                    items: ["端末情報"],
                    service: this.realtimeService,
                    trackService: this.trackService,
                    mapService: this.mapService,
                    // disabledColumns: [2,3,4,5,6,7,8,9,10,11,12],
                    order: [[1,"desc"]],
                    buttons: function (dataTable, editor) {
                    },
                    actionButtons: [],
                    leftButtons: [],
                    ajax: async function (handler) {
                        const params = {
                            email: '',
                            searchType: '',
                            searchValue: '',
                            groupId: ''
                        }
                        if (UserInfo.getInstance().getLoginType() == Const.ACCOUNT_TYPE_GROUP) {
                            params.groupId = UserInfo.getInstance().getGroupId()
                        } else {
                            params.email = UserInfo.getInstance().getEmail()
                        }
                        const response = await this.service.search(params)
                        if (response.statusCode != 200 || !response.data || response.data.length < 1) {
                            return handler([])
                        }
                        const jsons = []
                        for (const data of response.data) {

                            // チェックボックスの保存状態を確認
                            let display = false
                            let checks = localStorage.getItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_CHECKS)
                            if (checks) {
                                checks = JSON.parse(checks)
                                if (checks && checks.length > 0) {
                                    const check = checks.find(chk => {return chk.assetId == data.assetId})
                                    if (check) {
                                        display = check.checked
                                    }
                                }
                            }

                            const json = {
                                imei: data.imei,
                                gpsID: this.scrutiny(data.assetId),
                                assetId: data.assetId,
                                assetName: this.scrutiny(data.assetName) ? this.scrutiny(data.assetName) : '',
                                positionTime: '',
                                icon: data.icon,
                                lineColor: data.lineColor,
                                display: display,
                                displayName: this.scrutiny(data.assetName) ? this.scrutiny(data.assetName) : data.assetId,
                                rowId: data.rowId ? data.rowId : Math.random()
                            }

                            if (display) {
                                // 最新位置取得してWebSocket
                                const log = await self.loadNewestLog(data)
                                if (log) {
                                    json.positionTime = log.positionTime
                                }
                            }
                            jsons.push(json)
                        }

                        // お気に入りマークを考慮
                        const sorted = jsons.sort(function (a, b) {
                            const favorites = JSON.parse(localStorage.getItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_FAVORITE))
                            if (favorites && favorites.length) {
                                const fav1 = favorites.find(fav => {return fav.assetId == a.assetId})
                                const fav2 = favorites.find(fav => {return fav.assetId == b.assetId})
                                if (fav1 && !fav2) return -1
                                if (!fav1 && fav2) return 1
                            }
                            if(a.displayName > b.displayName) return 1
                            if(a.displayName < b.displayName) return -1
                            return 0
                        })
                        self.assetList = sorted

                        for (const history of RealtimeDataHolder.getInstance().getHistories()) {

                            const item = self.assetList.find(asset => asset.assetId == history.getAssetId())
                            history.setLineColor(item.lineColor)
                            history.setIcon(item.icon)
                            history.drawPolyline()
                            history.setHistories(this.addDegree(history.getHistories()))
                            // history.putArrows(self.getMiddlePoints(history.getHistories()), item.lineColor)
                            await history.drawDot()
                            if (!history.getCurrentMarker()) {
                                history.setCurrentMarker(
                                    history.getAssetName() ? history.getAssetName() : history.getAssetId(), history.getAssetId()
                                    // new MarkerWithLabel({
                                    // map: self.mapService.getMap(),
                                    // labelContent: history.getAssetName() ? history.getAssetName() : history.getAssetId(),
                                    // labelAnchor: new google.maps.Point(-40, 5),
                                    // labelClass: "labels"
                                // })
                            )
                            }
                            history.setCurrentMarkerPosition()
                            history.setClickCurrentMarker()
                        }
                        // フィッティング
                        const targets = RealtimeDataHolder.getInstance().getHistories().filter(d => {
                            return d.isVisible()
                        })
                        const boundsHistories = []
                        targets.forEach(hist => {
                            const hists = hist.getHistories()
                            if (hist && Array.isArray(hists) && hists.length) {
                                boundsHistories.push(hist.getHistories()[0])
                            }
                        })
                        if (boundsHistories && boundsHistories.length > 0) {
                            self.mapService.fitBounds(boundsHistories)
                        }

                        handler(sorted)
                    },
                    initComplete: function () {
                        let checks = localStorage.getItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_CHECKS)
                        if (!checks) return

                        checks = JSON.parse(checks)
                        if (!checks || checks.length < 1) return
                        const allCheck = checks.find(chk => {return chk.assetId == 'allCheck'})
                        if (!allCheck) return

                        $('input[name="allCheck"]').prop('checked', allCheck.checked)
                    },
                    // draw: function() {
                    // },
                    addJSON: function (json) {
                        const showCheckbox = function(data, type, row) {

                            let checks = localStorage.getItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_CHECKS)
                            if (checks) {
                                checks = JSON.parse(checks)
                                const check = checks.find(chk => {return chk.assetId == row.assetId})
                                if (check && check.checked === true) {
                                    return `<input type="checkbox" id="checkbox_${row.assetId}" name="checkbox_${row.assetId}" class="checkAsset" checked>`;
                                }
                                return `<input type="checkbox" id="checkbox_${row.assetId}" name="checkbox_${row.assetId}" class="checkAsset">`;
                            }
                            return `<input type="checkbox" id="checkbox_${row.assetId}" name="checkbox_${row.assetId}" class="checkAsset">`;
                        }
                        const assetIdFunc = function (data, type, row) {

                            const history = RealtimeDataHolder.getInstance().getHistories().find(history => {return history.assetId == data})
                            let onlineState = "offline"
                            if (history) {
                                const latest = history.getHistories()[0]
                                if (latest && latest.positionTime) {
                                    const minutes = Settings.getValue('gpsOnlineCondition')
                                    if (moment().diff(moment(latest.positionTime), "minutes") <= minutes) {
                                        onlineState = "online"
                                    }
                                }
                            }
                            let showStatus = 'hide'
                            let checks = localStorage.getItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_CHECKS)
                            if (checks) {
                                checks = JSON.parse(checks)
                                const check = checks.find(chk => {
                                    return chk.assetId == data
                                })
                                if (check && check.checked === true) {
                                    showStatus = ''
                                }
                            }

                            let positionTime = row.positionTime
                            let favorites = localStorage.getItem("fullMapFavorite")
                            if (!favorites) {
                                return `<div class="row-assetId favoriteimg">
                                        <div><img id="${data}-icon" style="height: 40px;" src="${row.icon ? row.icon : 'assets/images/map/maps-and-flags-l.png'}"/></div>
                                        <div class="asset-info">
                                            <div class="asset-info-top">
                                                <div>
                                                    <img class="favIcon" src="assets/images/map/hoshi_g.png" data-assetid="${row.assetId}"/>
                                                </div>
                                                <div id="${data}-assetName" class="text-assetId">${row.assetName ? row.assetName : row.assetId}</div>
                                            </div>
                                            <div class="asset-info-bottom">
                                                <div id="${data}-signal" class="glyphicon glyphicon-signal ${showStatus} ${onlineState}"></div>
                                                <div id="${data}-positionTime" class="realtime-positionTime">${positionTime}</div>
                                            </div>
                                        </div>
                                        <div id="${data}-setting-icon"  class="setting-icon" data-assetId="${data}" data-assetName="${row.assetName ? row.assetName: ''}"
                                            data-icon="${row.icon ? row.icon : ''}" data-lineColor="${row.lineColor ? row.lineColor : '#FF0000'}"><input type="hidden" id="assetInfo" value='${JSON.stringify(row)}' />
                                            <span class="glyphicon glyphicon-cog" style="color: ${row.lineColor ? row.lineColor : '#FF0000'}" data-assetid="${data}"></span>
                                        </div>
                                    </div>
                                   `
                            }
                            favorites = JSON.parse(favorites)
                            const favorite = favorites.find(fav => { return fav.assetId == data})
                            if (favorite) {
                                return `<div class="row-assetId favoriteimg">
                                        <div><img id="${data}-icon" style="height: 40px;" src="${row.icon ? row.icon : 'assets/images/map/maps-and-flags-l.png'}"/></div>
                                        <div class="asset-info">
                                            <div class="asset-info-top">
                                                <div><img class="favIcon" src="assets/images/map/hoshi_y.png" data-assetid="${row.assetId}"/></div>
                                                <div id="${data}-assetName" class="text-assetId">${row.assetName ? row.assetName : row.assetId}</div>
                                            </div>
                                            <div class="asset-info-bottom">
                                                <div id="${data}-signal" class="glyphicon glyphicon-signal ${showStatus} ${onlineState}"></div>
                                                <div id="${data}-positionTime" class="realtime-positionTime">${positionTime}</div>
                                            </div>
                                        </div>
                                        <div id="${data}-setting-icon"  class="setting-icon" data-assetId="${data}" data-assetName="${row.assetName ? row.assetName: ''}"
                                            data-icon="${row.icon ? row.icon : ''}" data-lineColor="${row.lineColor ? row.lineColor : '#FF0000'}"><input type="hidden" id="assetInfo" value='${JSON.stringify(row)}' />
                                            <span class="glyphicon glyphicon-cog" style="color: ${row.lineColor ? row.lineColor : '#FF0000'}" data-assetid="${data}"></span>
                                        </div>
                                    </div>
                                   `
                            }
                            return `<div class="row-assetId favoriteimg">
                                        <div><img id="${data}-icon" style="height: 40px;" src="${row.icon ? row.icon : 'assets/images/map/maps-and-flags-l.png'}"/></div>
                                        <div class="asset-info">
                                            <div class="asset-info-top">
                                                <div><img class="favIcon" src="assets/images/map/hoshi_g.png" data-assetid="${row.assetId}"/></div>
                                                <div id="${data}-assetName" class="text-assetId">${row.assetName ? row.assetName : row.assetId}</div>
                                            </div>
                                            <div class="asset-info-bottom">
                                                <div id="${data}-signal" class="glyphicon glyphicon-signal ${showStatus} ${onlineState}"></div>
                                                <div id="${data}-positionTime" class="realtime-positionTime">${positionTime}</div>
                                            </div>
                                        </div>
                                        <div id="${data}-setting-icon" class="setting-icon" data-assetId="${data}" data-assetName="${row.assetName ? row.assetName: ''}"
                                            data-icon="${row.icon ? row.icon : ''}" data-lineColor="${row.lineColor ? row.lineColor : '#FF0000'}">
                                            <span class="glyphicon glyphicon-cog" style="color: ${row.lineColor ? row.lineColor : '#FF0000'};"></span>
                                        </div>
                                    </div>
                                   `
                        }
                        json.columns.forEach(column => {
                            if (column.data == 'checkbox') {
                                column.render = showCheckbox;
                            }
                            if (column.data == 'assetId') {
                                column.render = assetIdFunc;
                            }
                        })

                        return json
                    },
                    numberLines: function (datatables) {
                        datatables.page.len(10).draw()
                    },
                    addDegree (histories) {
                        histories.forEach((history, idx) => {
                            if (idx == histories.length-1) return

                            const prev = history
                            const next = histories[idx+1]

                            if (!prev.latitude || !prev.longitude || !next.latitude || !next.longitude) return

                            let targetLat = prev.latitude
                            let targetlng = prev.longitude
                            if (idx > 0 && prev.latitude == next.latitude && prev.longitude == next.longitude) {
                                // 前回と同じ場合は2つ前のデータを参照
                                targetLat = histories[idx-1].latitude
                                targetlng = histories[idx-1].longitude
                                if (idx > 1 && targetLat == next.latitude && targetlng == next.longitude) {
                                    // 2つ前のデータも同じ場合は3つ前
                                    targetLat = histories[idx-2].latitude
                                    targetlng = histories[idx-2].longitude
                                    if (targetLat == next.latitude && targetlng == next.longitude) {
                                        //　従来のロジック
                                        targetLat = prev.latitude
                                        targetlng = prev.longitude
                                    }
                                }
                            }
                            const degree = geolib.getRhumbLineBearing(
                                {latitude: targetLat, longitude: targetlng},
                                {latitude: next.latitude, longitude: next.longitude})
                            next.degree = degree - 45
                        })
                        return histories
                    },
                    draw: function () {
                        const datatable =  $('#' + this.name + '_gpsdatatables').DataTable()
                        $('.checkAsset').off('change')
                        $('.checkAsset').on('change',async function (e) {
                            const checked = $(this).prop('checked')
                            const assetId = e.currentTarget.id.replace('checkbox_','')

                            let checks = localStorage.getItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_CHECKS)
                            if (!checks) {
                                checks = []
                            }
                            if (checks) {
                                checks = JSON.parse(localStorage.getItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_CHECKS))
                            }
                            if (!checks || checks.length < 1) {
                                checks = []
                                const checkStatus = {
                                    assetId: assetId,
                                    checked: checked
                                }
                                checks.push(checkStatus)
                            } else {
                                const chk = checks.find(chk => { return chk.assetId == assetId})
                                if (chk) {
                                    chk.checked = checked
                                } else {
                                    const checkStatus = {
                                        assetId: assetId,
                                        checked: checked
                                    }
                                    checks.push(checkStatus)
                                }
                            }

                            localStorage.setItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_CHECKS, JSON.stringify(checks))

                            if (checked) {
                                for (const asset of self.assetList) {
                                    if (assetId == asset.assetId) {
                                        // 最新位置取得
                                        const json = await self.loadNewestLog(asset)
                                        asset.display = true
                                        if (json && json.positionTime) {
                                            $(`#${assetId}-positionTime`).text(json.positionTime)
                                        }
                                    }
                                }

                                // const history = RealtimeDataHolder.getInstance().getHistories().find(history => { return history.assetId == assetId })
                                // if (!history || history.getHistories().length < 1) {
                                //     toastr.warning(`${assetId}のデータは存在しません`)
                                // }

                            } else {
                                self.assetList.forEach(asset => {
                                    if (assetId == asset.assetId) {
                                        asset.display = false
                                        const history = RealtimeDataHolder.getInstance().getHistories().find(history => {
                                            return history.getAssetId() == assetId
                                        })
                                        if (history) {
                                            history.setVisible(false)
                                        }
                                    }
                                    const client = RealtimeDataHolder.getInstance().getClients().find(client => { return client.getIMEI() == asset.imei})
                                    if (client) {
                                        client.close()
                                    }
                                })
                                $(`#${assetId}-signal`).addClass('hide')
                                $(`#${assetId}-positionTime`).text('')
                                $(`.labels.${assetId}`).remove()
                            }

                            for (const history of RealtimeDataHolder.getInstance().getHistories()) {
                                const item = self.assetList.find(asset => asset.assetId == history.getAssetId())
                                history.setLineColor(item.lineColor)
                                history.setIcon(item.icon)
                                history.drawPolyline()
                                history.setClickPolyline()
                                // history.putArrows(self.getMiddlePoints(history.getHistories()), item.lineColor)
                                await history.drawDot()
                                history.setDotClickMarker()
                                if (!history.getCurrentMarker()) {
                                    history.setCurrentMarker(
                                        history.getAssetName() ? history.getAssetName() : history.getAssetId(), history.getAssetId()
                                    // new MarkerWithLabel({
                                    //     map: self.mapService.getMap(),
                                    //     labelContent: history.getAssetName() ? history.getAssetName() : history.getAssetId(),
                                    //     labelAnchor: new google.maps.Point(-40, 5),
                                    //     labelClass: "labels"
                                    // }))
                                    )
                                }
                                history.setCurrentMarkerPosition()
                                history.setClickCurrentMarker()
                            }

                            const targets = RealtimeDataHolder.getInstance().getHistories().filter(d => {
                                return d.isVisible()
                            })
                            const boundsHistories = []
                            targets.forEach(hist => {
                                const hists = hist.getHistories()
                                if (hist && Array.isArray(hists) && hists.length) {
                                    boundsHistories.push(hist.getHistories()[0])
                                }
                            })
                            if (boundsHistories && boundsHistories.length > 0) {
                                self.mapService.fitBounds(boundsHistories)
                            }
                        })
                        $('input[name="allCheck"]').off('change')
                        $('input[name="allCheck"]').on('change',  {dt: datatable}, function (e) {
                            const checked = $(this).prop('checked')
                            const dt = e.data.dt
                            const pageInfo = dt.page.info()
                            for (let i = 1; i <= pageInfo.pages; i++) {
                                dt.page(i).draw('page')
                                $('.checkAsset').each(function() {
                                    $(this).prop('checked', checked).change()
                                })
                            }

                            const checks = JSON.parse(localStorage.getItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_CHECKS))
                            const saved = checks.find(chk => { return chk.assetId == 'allCheck'})
                            if (saved) {
                                saved.checked = checked
                            } else {
                                checks.push({
                                    assetId: 'allCheck',
                                    checked: checked
                                })
                            }
                            localStorage.setItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_CHECKS, JSON.stringify(checks))
                        })

                        // お気に入り機能
                        $('.favIcon').off('click')
                        $('.favIcon').on('click',  {dt: datatable}, function (e) {

                            let favorites = []
                            let data = localStorage.getItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_FAVORITE)
                            if (data) {
                                favorites = JSON.parse(data)
                            }
                            const assetId = $(this).data('assetid')
                            const checkbox = $('input[name="checkbox_' + assetId + '"]').prop('checked')
                            let favorite = _.findWhere(favorites, {assetId: assetId})
                            let found = true
                            if (!favorite) {
                                favorite = {
                                    assetId: assetId,
                                    checkbox: checkbox
                                }
                                found = false
                            }

                            const img = $(this).attr('src')
                            if (img.indexOf('hoshi_g') != -1) {
                                // お気に入り無効から有効にする
                                $(this).attr('src', "assets/images/map/hoshi_y.png")
                            } else {
                                // お気に入り有効から無効にする
                                $(this).attr('src', "assets/images/map/hoshi_g.png")
                                favorites = _.filter(favorites, function (fav) {
                                    return fav.assetId != assetId
                                })
                            }
                            if (!found) {
                                favorites.push(favorite)
                            }
                            localStorage.setItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_FAVORITE, JSON.stringify(favorites))

                            // ソート
                            data = e.data.dt.rows().data()
                            const sorted = data.sort(function (a, b) {
                                const favorites = JSON.parse(localStorage.getItem(Const.LOCAL_STORAGE_KEY_FULL_MAP_FAVORITE))
                                if (favorites && favorites.length) {
                                    const fav1 = favorites.find(fav => {return fav.assetId == a.assetId})
                                    const fav2 = favorites.find(fav => {return fav.assetId == b.assetId})
                                    if (fav1 && !fav2) return -1
                                    if (!fav1 && fav2) return 1
                                }
                                if(a.displayName > b.displayName) return 1
                                if(a.displayName < b.displayName) return -1
                                return 0
                            })
                            _.each(sorted, function (d, idx) {
                                e.data.dt.row(idx).data(d).draw()
                            })

                        })

                        $('.setting-icon').off('click')
                        $('.setting-icon').on('click',  {assetList: self.assetList}, function (e) {

                            const assetInfo = {
                                assetId: this.getAttribute('data-assetid'),
                                assetName: this.getAttribute('data-assetname'),
                                lineColor: this.getAttribute('data-linecolor'),
                                icon: this.getAttribute('data-icon')
                            }

                            riot.unmount('commonmodal', {}, 'realtimemodal')
                            const realtimeModal = riot.mount('commonmodal',{
                                assetInfo,
                                assetList: e.data.assetList
                            }, 'realtimemodal')[0]
                            realtimeModal.show()
                            return
                        })
                    }
                    // open: function (e, json, action, editor) {
                    //
                    // }
                }, "realtimedatatables", true)
            },
            webSocket(imei) {
                const client = new MultipleWebSocketClient()
                client.prepare(imei)
                client.onOpen()
                client.onClose()
                client.onError()
                client.onMessage(this.draw)
                RealtimeDataHolder.getInstance().pushClient(client)
            },
            async loadNewestLog(data) {
                const result = await this.mapService.loadNewestLog(data.imei, data.assetId)
                if (result.message) {
                    // toastr.warning(`${data.assetId}のデータは存在しません`)
                    return
                }
                const json = result.data
                if (!json) {
                    // toastr.warning(`${data.assetId}のデータは存在しません`)
                    return
                }

                let history = RealtimeDataHolder.getInstance().getHistories().find(history => {
                    return history.getAssetId() == data.assetId
                })

                if (history) {
                    history.setVisible(true)
                    // 非表示中に受信したデータを追加
                    await this.getLostLog(data.assetId, history.getHistories()[0])
                    this.webSocket(data.imei)
                    if (json.positionTime) {
                        const minutes = Settings.getValue('gpsOnlineCondition')
                        let onlineState = "offline"
                        if (moment().diff(moment(json.positionTime), "minutes") <= minutes) {
                            onlineState = "online"
                        }
                        $(`#${history.getAssetId()}-signal`).removeClass('offline hide online').addClass(onlineState)
                    }
                    return json
                }

                // 履歴に空データを登録
                history = new MultipleTrackHistory()
                history.setAssetId(this.scrutiny(data.assetId))
                history.setAssetName(this.scrutiny(data.assetName))
                history.setVisible(true)
                if (json.positionTime && json.latitude && json.longitude) {
                    const minutes = Settings.getValue('gpsOnlineCondition')
                    let onlineState = "offline"
                    if (moment().diff(moment(json.positionTime), "minutes") <= minutes) {
                        onlineState = "online"
                    }
                    const info = {
                        imei: data.imei,
                        gpsID: this.scrutiny(data.assetId),
                        assetId: this.scrutiny(data.assetId),
                        assetName: data.assetName ? data.assetName : '',
                        online: onlineState,
                        altitude: json.altitude,
                        eventCode: json.eventCode,
                        address: json.address,
                        battery: json.battery,
                        eventTitle: json.eventTitle,
                        accuracy: json.accuracy,
                        eventIcon: json.eventIcon,
                        longitude: json.longitude,
                        latitude: json.latitude,
                        stoppingTime: json.stoppingTime,
                        speed: json.speed,
                        positionTime: json.positionTime,
                        batteryIcon: MapUtil.getBatteryIcon(json.battery),
                        streetView: true,
                        display: true
                    }
                    history.push(info)
                    // riot.unmount('historygpsinfowindowview', {}, '')
                    // $('#history-info-window-content').remove()
                    const historygpsinfowindowview = riot.mount('historygpsinfowindowview', {
                        mapService: this.mapService,
                        assetData: data
                    })[0]
                    historygpsinfowindowview.setInfo(info)
                    history.setInfoWindowView(historygpsinfowindowview)
                    history.setHistoryInfoWindowContent( historygpsinfowindowview.domContent())

                    $(`#${history.getAssetId()}-signal`).removeClass('offline hide online').addClass(onlineState)
                }
                RealtimeDataHolder.getInstance().pushHistory(history)

                // websocket
                this.webSocket(data.imei)

                return json
            },
            async draw(data, imei) {
                const self = this
                for (const asset of this.assetList) {
                    if (asset.imei == imei) {
                        // 現在地を書き換える
                        asset.latitude = data.latitude
                        asset.longitude = data.longitude
                        asset.positionTime = data.positionTime
                        asset.online = 'online'
                        asset.eventCode = data.eventCode
                        asset.address = data.address
                        asset.battery = data.battery
                        asset.accuracy = data.accuracy
                        asset.eventIcon = data.eventIcon
                        asset.stoppingTime = data.stoppingTime
                        asset.speed = data.speed
                        asset.streetView = true
                        asset.batteryIcon = MapUtil.getBatteryIcon(data.battery)

                        // 履歴を追加
                        const history = RealtimeDataHolder.getInstance().getHistories().find(history => {
                            return history.getAssetId() == asset.assetId
                        })
                        const info = {
                            imei: data.imei,
                            latitude: data.latitude,
                            longitude: data.longitude,
                            positionTime: data.positionTime,
                            online: 'online',
                            eventCode: data.eventCode,
                            address: data.address,
                            battery: data.battery,
                            eventTitle: data.eventTitle,
                            accuracy: data.accuracy,
                            eventIcon: data.eventIcon,
                            stoppingTime: data.stoppingTime,
                            speed: data.speed,
                            streetView: true,
                            batteryIcon: MapUtil.getBatteryIcon(data.battery)
                        }
                        history.push(info)
                        // 線を引く
                        history.setLineColor(asset.lineColor)
                        history.setIcon(asset.icon)
                        history.drawPolyline()
                        // history.putArrows(self.getMiddlePoints(history.getHistories()), asset.lineColor)
                        await history.drawDot()
                        history.setClickPolyline()
                        history.setDotClickMarker()
                        if (!history.getCurrentMarker()) {
                            history.setCurrentMarker(history.getAssetName() ? history.getAssetName() : history.getAssetId(), history.getAssetId())
                            // new MarkerWithLabel({
                            //     map: self.mapService.getMap(),
                            //     labelContent: history.getAssetName() ? history.getAssetName() : history.getAssetId(),
                            //     labelAnchor: new google.maps.Point(-40, 5),
                            //     labelClass: "labels"
                            // }))
                        }
                        history.setCurrentMarkerPosition()
                        history.setClickCurrentMarker()
                        history.getInfoWindowView().setInfo(info)

                        $(`#${history.getAssetId()}-signal`).removeClass('offline online').addClass('online')
                        $(`#${history.getAssetId()}-positionTime`).text(info.positionTime)
                    }
                }

                // フィッティング
                const targets = RealtimeDataHolder.getInstance().getHistories().filter(d => {
                    return d.isVisible()
                })
                const boundsHistories = []
                targets.forEach(hist => {

                    const hists = hist.getHistories()
                    if (hist && Array.isArray(hists) && hists.length) {
                        boundsHistories.push(hist.getHistories()[hist.getHistories().length - 1])
                    }
                })
                if (boundsHistories && boundsHistories.length > 0) {
                    self.mapService.fitBounds(boundsHistories)
                }
            },
            async getLostLog (assetId, firstLog) {
                const start = moment().hour(0).minute(0).second(0).format("YYYY-MM-DD HH:mm:ss")
                const end = moment().hour(23).minute(59).second(59).format("YYYY-MM-DD HH:mm:ss")
                const histories = await this.trackService.search(start, end, assetId)
                if (histories.statusCode != 200) {
                    toastr.error(histories.message)
                }
                histories.data.forEach(data => {
                    data.batteryIcon = MapUtil.getBatteryIcon(data.battery)
                    let onlineState = "offline"
                    const minutes = Settings.getValue('gpsOnlineCondition')
                    if (moment().diff(moment(data.positionTime), "minutes") <= minutes) {
                        onlineState = "online"
                    }
                    data.online = onlineState
                })

                if (!histories.data || histories.data.length < 1) return

                // 本日分以外のデータを削除して結合する
                const filtered = histories.data.filter(function (data) {
                    const target = moment(data.positionTime)
                    const first = moment(firstLog.positionTime)
                    return target.isSameOrAfter(first)
                })

                const history = RealtimeDataHolder.getInstance().getHistories().find(history => { return history.assetId == assetId })
                history.setHistories(filtered)
                history.getInfoWindowView().setInfo(filtered[filtered.length-1])
            }
        }

    </script>
</mapsidebar>
